#ifndef CENUMCONNECTIONS_H
#define CENUMCONNECTIONS_H

class CEnumConnections : public IEnumConnections
{
public:
    //IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    IFACEMETHOD(Next)(ULONG cConnections, LPCONNECTDATA rgcd, ULONG* pcFetched);
    IFACEMETHOD(Skip)(ULONG cConnections);
    IFACEMETHOD(Reset)();
    IFACEMETHOD(Clone)(IEnumConnections** ppEnum);

    explicit CEnumConnections(CConnectionPoint* pItf);

private:
    virtual ~CEnumConnections();
    CEnumConnections(const CEnumConnections& other);
    CEnumConnections& operator=(const CEnumConnections& other);

    CConnectionPoint*   m_pItf;
    volatile ULONG      m_lCursor;
    volatile ULONG      m_lRefCount;
};

#endif
