#ifndef CENUMVARIANT_H
#define CENUMVARIANT_H

class CEnumVARIANT : public IEnumVARIANT
{
public:
    // IUnknown
    IFACEMETHOD(QueryInterface) (REFIID riid, void** ppvObject);
    IFACEMETHOD_(ULONG, AddRef) ();
    IFACEMETHOD_(ULONG, Release)();

    // IEnumVARIANT
    IFACEMETHOD(Next)(ULONG celt, VARIANT* rgVar, ULONG* pCeltFetched);
    IFACEMETHOD(Skip)(ULONG celt);
    IFACEMETHOD(Reset)();
    IFACEMETHOD(Clone)(IEnumVARIANT** ppEnum);

    explicit CEnumVARIANT(CSmartICE04Devices* pDevices);

private:
    virtual ~CEnumVARIANT();

    CSmartICE04Devices* m_pDevices;
    volatile ULONG      m_lRefCount;
    volatile LONG       m_lCursor;
};

#endif
