#ifndef CEVENTSINK_H
#define CEVENTSINK_H

class DECLSPEC_NOVTABLE CEventSink : public IUnknown
{
protected:
    CEventSink() : m_dwCookie(0), m_pCP(nullptr) {}
    virtual ~CEventSink() { Disconnect(); }

public:
    HRESULT ConnectTo(IUnknown* pUnk, REFIID riid);
    HRESULT Disconnect();

private:
    CEventSink(const CEventSink& other);
    CEventSink& operator=(const CEventSink& other);

    DWORD m_dwCookie;

#ifdef _WIN64
    BYTE bPadding[4]; // C4820
#endif

protected:
    IConnectionPoint* m_pCP;
};

#endif
